﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;

namespace Ad01
{
    public static class Ad
    {
        public static void ShowAd(Settings adSettings)
        {
            if (!Directory.Exists(@"Mods\\01STUDIO\\" + adSettings.nameMod))
            {
                Directory.CreateDirectory(@"Mods\\01STUDIO\\" + adSettings.nameMod);
                DialogBox trailer = (DialogBox)null;
                DialogBox discordInvite = (DialogBox)null;
                trailer = DialogBoxManager.Dialog(adSettings.meetLabel, new DialogButton[]
                {
                    new DialogButton("Let's skip this", true, () =>
                    {
                        ShowDialog(discordInvite);
                    }),
                    new DialogButton("Go, I want", true, () =>
                    {
                        OpenLink(adSettings.videoLink);
                        ShowDialog(discordInvite);
                    })
                });
                discordInvite = DialogBoxManager.Dialog(adSettings.middleLabel, new DialogButton[]
                {
                    new DialogButton("Join the community on Discord", false, () =>
                    {
                        OpenLink("https://discord.gg/tUvF8jmbWm");
                    }),

                    new DialogButton("Close forever", true, () => DialogBoxManager.Notification("Thanks for installing the mod. \nYours 01 Studio"))
                });
                if (adSettings.needAdBoosty)
                {
                    discordInvite.Buttons = new DialogButton[]
                {
                    new DialogButton("Discord", false, () =>
                    {
                        OpenLink("https://discord.gg/tUvF8jmbWm");
                    }),
                    new DialogButton("YouTube", false, () =>
                    {
                        OpenLink("https://www.youtube.com/channel/UCI6xQUt7b2BYeqOPCeA-XsQ");
                    }),
                    new DialogButton("Support Developer", false, () =>
                    {
                        OpenLink("https://boosty.to/dyadyushkadyadya");
                    }),
                    new DialogButton("Our site with other our mods", false, () =>
                    {
                        OpenLink("https://01studio.ru");
                    }),
                    new DialogButton("Close forever", true, () => DialogBoxManager.Notification("Thanks for installing the mod. \nYours 01 Studio")) };
                }
                HideDialog(discordInvite);
            }
        }
        private static void OpenLink(string url)
        {
            Type type = Type.GetType("UnityEngine.Application, UnityEngine.CoreModule");
            type.GetMethod("OpenURL", BindingFlags.Public | BindingFlags.Instance | BindingFlags.Static).Invoke(null, new object[] { url });
        }
        private static void ShowDialog(DialogBox dialogBox)
        {
            dialogBox.gameObject.SetActive(true);
        }
        private static void HideDialog(DialogBox dialogBox)
        {
            dialogBox.gameObject.SetActive(false);
        }
        public struct Settings
        {
            public string nameMod;
            public string discordLink;
            public string videoLink;
            public string meetLabel;
            public string middleLabel;
            public bool needAdBoosty;
            public Settings(string nameMod, string linkOnVideo, bool needAdBoosty = true, string meetLabel = "Do you want to know how and where you can use the functions of this mod?", string middleLabel = "You can support us or go to our discord if you like our creativity.", string discordLink = "https://discord.gg/tUvF8jmbWm")
            {
                this.nameMod = nameMod;
                this.discordLink = discordLink;
                this.videoLink = linkOnVideo;
                this.meetLabel = meetLabel;
                this.middleLabel = middleLabel;
                this.needAdBoosty = needAdBoosty;
            }

        }
    }
}
