using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Utility01;
using Ad01;
using UnityEngine.UI;
using System.Threading.Tasks;
using System.Linq;

namespace Mod
{
    public class Mod
    {
        public static string blogPost = "https://youtu.be/PyZpsMb98EU";
        public static void OnLoad()
        {
            Ad.ShowAd(new Ad.Settings("Ultimate Map Blocks", "https://youtu.be/PyZpsMb98EU", true, "Hi!\nThis mod adds blocks such as \nBlocks of maps, snow, ice, water, lava\nThe construction system has a specific device \nAir defense to avoid questions, I strongly recommend viewing the tutorial!", "It took me quite a while to figure out how to do all this so you guys could safely build,\nsave and post your work using these blocks, but it worked!\nI would be glad to get your support if you really like what I'm doing, thanks to everyone who supports me on Boosty!"));
        }
        public static void RegisterCategory(string name, string description, Sprite icon)
        {
            /*Category category = ScriptableObject.CreateInstance<Category>();
            category.name = name;
            category.Description = description;
            category.Icon = icon;
            CatalogBehaviour.Main.ModdedCatalog.Add(category);*/
            CatalogBehaviour manager = UnityEngine.Object.FindObjectOfType<CatalogBehaviour>();
            if (manager.Catalog.Categories.FirstOrDefault((Category c) => c.name == name) == null)
            {
                Category category = ScriptableObject.CreateInstance<Category>();
                category.name = name;
                category.Description = description;
                category.Icon = icon;
                Category[] NewCategories = new Category[manager.Catalog.Categories.Length + 1];
                Category[] categories = manager.Catalog.Categories;
                for (int i = 0; i < categories.Length; i++)
                {
                    NewCategories[i] = categories[i];
                }
                NewCategories[NewCategories.Length - 1] = category;
                manager.Catalog.Categories = NewCategories;
            }
        }
        public static void Main()
        {
            string pathSprites = "Sprites/";
            RegisterCategory("Ultimate Map Blocks", "Contains all the blocks of maps.", ModAPI.LoadSprite(pathSprites + "category.png"));

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Map Block",
                    DescriptionOverride = "Just a block, nothing special",
                    NameToOrderByOverride = "mapult_1",
                    CategoryOverride = ModAPI.FindCategory("Ultimate Map Blocks"),
                    ThumbnailOverride = ModAPI.LoadSprite(pathSprites + "blockThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var spriteRenderer = Instance.GetComponent<SpriteRenderer>();
                        spriteRenderer.sprite = ModAPI.LoadSprite(pathSprites + "block.png");
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = MapRegistry.GetMap("fb813068-e717-45de-a97f-4677a41758e6").Prefab.transform.Find("Root/Left wall").gameObject.GetPhysicalProperties();
                        Instance.AddComponent<OutlineRemover>();
                        Instance.FixColliders();
                        var blockBehaviour = Instance.AddComponent<BlockBehaviour>();
                        blockBehaviour.physicalBlock = true;
                        spriteRenderer.sortingLayerName = "Top";
                        spriteRenderer.sortingOrder = 1;
                        Instance.AddComponent<TemperatureControllerBlock>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Water Block",
                    DescriptionOverride = "It can be changed to any liquid by the name that can be obtained in the analyzer. The change takes place in the context menu.",
                    NameToOrderByOverride = "mapult_2",
                    CategoryOverride = ModAPI.FindCategory("Ultimate Map Blocks"),
                    ThumbnailOverride = ModAPI.LoadSprite(pathSprites + "seaThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var spriteRenderer = Instance.GetComponent<SpriteRenderer>();
                        spriteRenderer.sprite = ModAPI.LoadSprite(pathSprites + "sea.png");
                        spriteRenderer.color = new Color(0, 0, 0, 0);

                        Instance.FixColliders();
                        var map = MapRegistry.GetMap("35a41d94-8bc7-47a2-93de-3a297955e97c");
                        var prefabSea = map.Prefab.transform.Find("Root/Sea").gameObject;
                        Instance.AddComponent<OutlineRemover>();
                        var seaObject = Utility.CreateChildObject(prefabSea, Instance.transform);
                        Utility.SetPositionWithOffSet(seaObject.transform, Instance.transform);
                        var blockBehaviour = Instance.AddComponent<BlockBehaviour>();
                        blockBehaviour.physicalBlock = false;
                        seaObject.transform.localScale = new Vector3(seaObject.transform.localScale.x, seaObject.transform.localScale.y * -1);
                        //

                        var waterBlock = Instance.GetOrAddComponent<WaterBlock>();
                        waterBlock.seaObject = seaObject.transform;
                        blockBehaviour.DeleteInvisibleOutline(spriteRenderer);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Ice Block",
                    DescriptionOverride = "Like water, only frozen, always, suddenly you want to arrange a skating rink in a lava lake.",
                    NameToOrderByOverride = "mapult_3",
                    CategoryOverride = ModAPI.FindCategory("Ultimate Map Blocks"),
                    ThumbnailOverride = ModAPI.LoadSprite(pathSprites + "ice.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var spriteRenderer = Instance.GetComponent<SpriteRenderer>();
                        spriteRenderer.sprite = ModAPI.LoadSprite(pathSprites + "snow.png");
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        Instance.AddComponent<OutlineRemover>();
                        Instance.FixColliders();
                        var blockBehaviour = Instance.AddComponent<BlockBehaviour>();
                        blockBehaviour.physicalBlock = true;
                        spriteRenderer.sortingLayerName = "Top";
                        spriteRenderer.sortingOrder = -1;
                        Instance.AddComponent<TemperatureControllerBlock>().temperature = -1;
                        spriteRenderer.material = MapRegistry.GetMap("35a41d94-8bc7-47a2-93de-3a297955e97c").Prefab.transform.Find("Root/Sea").gameObject.GetComponent<SpriteRenderer>().material;
                        spriteRenderer.material.SetFloat("_Temperature", -10);
                        Instance.transform.localScale = new Vector3(Instance.transform.localScale.x, Instance.transform.localScale.y * -1);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Lava Block",
                    DescriptionOverride = "It's lava, right.",
                    NameToOrderByOverride = "mapult_4",
                    CategoryOverride = ModAPI.FindCategory("Ultimate Map Blocks"),
                    ThumbnailOverride = ModAPI.LoadSprite(pathSprites + "lava.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var spriteRenderer = Instance.GetComponent<SpriteRenderer>();
                        spriteRenderer.sprite = ModAPI.LoadSprite(pathSprites + "sea.png");
                        spriteRenderer.color = new Color(1, 0, 0, 0);
                        Debug.Log(spriteRenderer.gameObject.name);
                        Instance.FixColliders();
                        var map = MapRegistry.GetMap("498b4aad-0ccc-4167-aee2-324a28cd57ae");
                        var prefabLava = map.Prefab.transform.Find("Lava pool").gameObject;
                        Instance.AddComponent<OutlineRemover>();
                        var lavaObject = Utility.CreateChildObject(prefabLava, Instance.transform);
                        Utility.SetPositionWithOffSet(lavaObject.transform, Instance.transform);
                        var blockBehaviour = Instance.AddComponent<BlockBehaviour>();
                        blockBehaviour.physicalBlock = false;
                        lavaObject.transform.localScale = new Vector3(lavaObject.transform.localScale.x, lavaObject.transform.localScale.y * -1);
                        lavaObject.transform.Find("Ambience").gameObject.SetActive(false);
                        var lavaSpriteRenderer = lavaObject.GetComponent<SpriteRenderer>();
                        lavaSpriteRenderer.sortingOrder = -1;
                        lavaObject.name = "Lava pool";
                        blockBehaviour.DeleteInvisibleOutline(spriteRenderer);

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Snow Block",
                    DescriptionOverride = "Just a white cold block",
                    NameToOrderByOverride = "mapult_5",
                    CategoryOverride = ModAPI.FindCategory("Ultimate Map Blocks"),
                    ThumbnailOverride = ModAPI.LoadSprite(pathSprites + "snowThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var spriteRenderer = Instance.GetComponent<SpriteRenderer>();
                        spriteRenderer.sprite = ModAPI.LoadSprite(pathSprites + "snow.png");
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        Instance.AddComponent<OutlineRemover>();
                        Instance.FixColliders();
                        var blockBehaviour = Instance.AddComponent<BlockBehaviour>();
                        blockBehaviour.physicalBlock = true;
                        spriteRenderer.sortingLayerName = "Top";
                        spriteRenderer.sortingOrder = 1;
                        Instance.AddComponent<TemperatureControllerBlock>().temperature = -1;
                        phys.Properties = MapRegistry.GetMap("3924fb95-dc1d-43e9-b8b1-b161b91c1f9b").Prefab.transform.Find("Root").gameObject.GetPhysicalProperties();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Watch Tutorial",
                    DescriptionOverride = "If you don't understand a thing",
                    NameToOrderByOverride = "mapult_6",
                    CategoryOverride = ModAPI.FindCategory("Ultimate Map Blocks"),
                    ThumbnailOverride = ModAPI.LoadSprite(pathSprites + "watch.jpg"),
                    AfterSpawn = (Instance) =>
                    {
                        GameObject.Destroy(Instance);
                    }
                }
            );
            ModAPI.Register<ButtonTutorialLoader>();
        }
    }
    public class ButtonTutorialLoader : MonoBehaviour
    {
        public List<Transform> transforms = new List<Transform>();
        private void Start()
        {
            var category = ModAPI.FindCategory("Ultimate Map Blocks");
            for (var i = 0; i < GameObject.Find("Canvas/Catalog/ItemPanel/Viewport/Content").transform.childCount; i++)
            {
                transforms.Add(GameObject.Find("Canvas/Catalog/ItemPanel/Viewport/Content").transform.GetChild(i));
            }
            transforms.Remove(GameObject.Find("Canvas/Catalog/ItemPanel/Viewport/Content").transform.GetChild(0));
            foreach (Transform transform in transforms)
            {
                if (transform.gameObject.GetComponent<ItemButtonBehaviour>().Item.Category == category)
                {
                    if (transform.gameObject.GetComponent<ItemButtonBehaviour>().Item.name == "Watch Tutorial")
                    {
                        transform.gameObject.GetComponent<Button>().onClick.AddListener(() => Utility.OpenLink(Mod.blogPost));
                    }
                }
            }
            UnityEngine.Object.Destroy(this);
        }
    }
    public class TryDeleteAudioSource : MonoBehaviour
    {
        bool done = false;
        public void Update()
        {
            if (!done)
            {
                try
                {
                    UnityEngine.Object.Destroy(gameObject.GetComponent<AudioSource>());
                    done = true;
                }
                catch
                {
                }
            }
        }
    }
    public class WaterBlock : MonoBehaviour
    {
        public Transform seaObject;
        public LiquidWater liquidWater;
        public string lastLiquidDisplayName = "Acid";
        public string lastType = "water";
        public void Start()
        {
            liquidWater = seaObject.gameObject.GetOrAddComponent<LiquidWater>();
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton(() => !seaObject.gameObject.activeInHierarchy || liquidWater.activate, "fillWater", "Fill Water", "", () => SetLiquid("water")));
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton(() => !liquidWater.activate, "fillLiquid", () => "Fill " + Liquid.GetLiquid(liquidWater.nowLiquidID).GetDisplayName(), "", () => SetLiquid("liquid")));
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("changeLiquid", "Change Liquid", "", () =>
            {
                DialogBox dialogBox = (DialogBox)null;
                dialogBox = DialogBoxManager.TextEntry("Change liquid", "<size=75%>Enter the name of the liquid\nyou can get it in the liquid analyzer", new DialogButton[]
                {
                    new DialogButton("Cancel", true, () => dialogBox.Close()),
                    new DialogButton("Enter", true, () => liquidWater.ChangeLiquid(dialogBox.EnteredText))
                });
            }));
            liquidWater.waterBlock = this;
            gameObject.UpdateOutline();
            seaObject.Find("Ambience").gameObject.AddComponent<TryDeleteAudioSource>();
            seaObject.Find("Ambience").gameObject.GetComponent<WaterSoundBehaviour>().enabled = false;
        }
        public void SetLiquid(string liquid)
        {
            switch (liquid)
            {
                case "water":
                    {
                        liquidWater.Fill(false);
                        seaObject.gameObject.SetActive(true);
                        break;
                    }
                case "liquid":
                    {
                        liquidWater.Fill(true);
                        seaObject.gameObject.SetActive(true);
                        break;
                    }
            }
            lastType = liquid;
        }

    }
    public class LiquidWater : MonoBehaviour
    {
        public bool activate = false;
        public Collider2D collider;
        public Color normalColor = new Color(0.165f, 0.3197f, 0.3396f, 0.6078f);
        public Color nowColor = new Color(0, 0.6703f, 0, 0.7878f);
        public Material material;
        public string nowLiquidID = "ACID";
        public Dictionary<string, Liquid> allLiquidsOfName = new Dictionary<string, Liquid>();
        public WaterBlock waterBlock;
        private void Start()
        {
            collider = waterBlock.seaObject.gameObject.GetComponent<Collider2D>();
            material = waterBlock.seaObject.gameObject.GetComponent<SpriteRenderer>().material;
            foreach (var liquid in Liquid.GetLiquid(nowLiquidID).GetAll())
            {
                try
                {
                    if (!allLiquidsOfName.ContainsKey(liquid.GetDisplayName().ToLower()))
                    {
                        allLiquidsOfName.Add(liquid.GetDisplayName().ToLower(), liquid);
                    }
                }
                catch { }
            }
            ChangeLiquid(waterBlock.lastLiquidDisplayName, false);
            waterBlock.SetLiquid(waterBlock.lastType);
        }
        private void Update()
        {

            if (activate)
            {
                foreach (var obj in Utility.InCollider(collider))
                {
                    if (obj.gameObject.TryGetComponent<LimbBehaviour>(out LimbBehaviour limbBehaviour))
                    {
                        limbBehaviour.CirculationBehaviour.AddLiquid(Liquid.GetLiquid(nowLiquidID), 0.05f * Time.deltaTime);
                    }
                }
            }
        }
        public void Fill(bool fill = true)
        {
            activate = fill;
            nowColor = new Color(nowColor.r, nowColor.g, nowColor.b, 0.6f);
            material.SetColor("_Tint", activate == true ? nowColor : normalColor);
            material.SetColor("_DepthColour", activate == true ? nowColor : normalColor);
        }
        public void ChangeLiquid(string displayLiquidName, bool notify = true)
        {
            if (allLiquidsOfName.ContainsKey(displayLiquidName.ToLower()))
            {
                var liquid = allLiquidsOfName[displayLiquidName.ToLower()];
                nowLiquidID = Liquid.GetIdentity(liquid);
                nowColor = liquid.Color;
                if (notify)
                {
                    Utility.SuccessfulNotify("You changed the liquid to " + displayLiquidName);
                }
                waterBlock.lastLiquidDisplayName = displayLiquidName;
                if (waterBlock.lastType == "liquid")
                {
                    waterBlock.SetLiquid("liquid");
                }
            }
            else
            {
                if (notify)
                {
                    Utility.ErrorNotify("Incorrect name of the liquid");
                }
            }
        }
    }
    public class TemperatureControllerBlock : MonoBehaviour
    {
        public PhysicalBehaviour physicalBehaviour;
        public float temperature = 16;
        public void Start()
        {
            physicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
        }
        public void Update()
        {
            physicalBehaviour.Temperature = temperature;
        }
    }
    public class BlockBehaviour : MonoBehaviour
    {

        public FreezeBehaviour freezeBehaviour;
        public PhysicalBehaviour physicalBehaviour;
        public PolygonCollider2D collider;
        public bool physicalBlock = true;
        public void Start()
        {
            physicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
            physicalBehaviour.Disintegratable = false;
            gameObject.layer = 11;
        }
        public void Update()
        {
            if (!freezeBehaviour)
            {
                freezeBehaviour = gameObject.AddComponent<FreezeBehaviour>();
            }
            if (collider == null)
            {
                collider = gameObject.GetComponent<PolygonCollider2D>();
            }

            if (Global.main.Paused)
            {
                if (Time.timeScale <= 0.00001f || collider.InCollider().Length == 0)
                {
                    physicalBehaviour.Selectable = true;
                    collider.isTrigger = false;
                    gameObject.layer = 9;
                }
            }
            else
            {
                physicalBehaviour.Selectable = false;
                collider.isTrigger = !physicalBlock;
                gameObject.layer = 11;
            }
        }
        public void DeleteInvisibleOutline(SpriteRenderer spriteRenderer)
        {
            spriteRenderer.material = ModAPI.FindMaterial("Sprites-Default");
            spriteRenderer.color = new Color(0, 0, 0, 0);
        }
    }
    public class MapRemover : MonoBehaviour
    {
        private void OnCollisionEnter2D(Collision2D coll)
        {
            if (coll.gameObject.layer == 11 && coll.gameObject.GetComponent<MapFreezerDrag>())
            {
                Destroy(coll.gameObject);
            }
        }
    }
    public class OutlineRemover : MonoBehaviour
    {
        private void Update()
        {
            if (gameObject.transform.Find("Outline"))
            {
                GameObject.Destroy(gameObject.transform.Find("Outline").gameObject);
            }
        }
    }
    public class MapFreezerDrag : MonoBehaviour
    {
        public FreezeBehaviour freezeBehaviour;
        private void Start()
        {
            OnMouseUp();
        }
        private void Update()
        {
            gameObject.GetOrAddComponent<PhysicalBehaviour>().Temperature = MapConfig.Instance.Settings.Ambient_temperature;
        }
        private void OnMouseUp()
        {
            freezeBehaviour = gameObject.GetOrAddComponent<FreezeBehaviour>();
        }
        private void OnMouseDown()
        {
            UnityEngine.Object.Destroy(freezeBehaviour);
        }
        private void OnMouseOver()
        {
            Debug.Log("over");
            gameObject.layer = 9;
        }
        private void OnMouseExit()
        {
            Debug.Log("exit");
            gameObject.layer = 11;
        }
    }
}
